var jsonProxy = function()
{
	var flashObject = null;
	
	// Create only if it doesn't exist
	if (!window.CustomEvent) { 
	    (function () {
	        function CustomEvent ( event, params ) {
	            params = params || { bubbles: false, cancelable: false, detail: undefined };
	            var evt = document.createEvent( 'CustomEvent' );
	            evt.initCustomEvent( event, params.bubbles, params.cancelable, params.detail );
	            return evt;
	        };

	        CustomEvent.prototype = window.Event.prototype;

	        window.CustomEvent = CustomEvent;
	    })();
	}
	
	return {
		setupFlash : function(flashId)
		{
			flashObject = document.getElementById(flashId);
		}
		,
		callback : function(pCallBack, response)
		{
        	if(typeof pCallBack != "undefined") {
        		if(flashObject) {
    				flashObject.onCallback(pCallBack, response);
    			} else {
	            	var div;
	            	var canvas = document.getElementsByTagName("canvas");
	            	if(canvas.length > 0) { div = canvas[0]; }
	            	if(typeof jsembed != "undefined") { div = jsembed.embedDiv(); }
	            	if(div) { 
	            		div.dispatchEvent(new CustomEvent(pCallBack, {detail:{name:pCallBack, res:response}}));
	            	}
    			}
            }
		}
		,
		sendEvent : function(pUrl, pData, pType, pCallBack, pJson)
		{
			var xhr;
			if(window.XMLHttpRequest) { xhr = new XMLHttpRequest(); ;}
			else { xhr = new ActiveXObject("Microsoft.XMLHTTP"); }
			xhr.open(pType, pUrl, true);
			xhr.withCredentials = true;
			if(pJson) { xhr.setRequestHeader("Content-Type", "application/json"); }
			else if (pType == "POST") { xhr.setRequestHeader("Content-type","application/x-www-form-urlencoded"); }
            xhr.onerror = function(err) { 
            	//console.log("onerror"); console.log(err); 
            	jsonProxy.callback(pCallBack, null);
            };
            xhr.onload = function(_) 
            { 
            	var response = window.JSON.parse(xhr.response);
            	//console.log("onload"); console.log(response);
            	jsonProxy.callback(pCallBack, response);
            };
	        if(pType == "POST") { 
	        	var data;
	        	if(pJson) { data = JSON.stringify(pData); }
	        	else { data = pData; }
	        	xhr.send(data); 
	        } else { 
	        	xhr.send(); 
	        }
		}
	};
}();
